package cn.wise.sc.consume.business.service.impl;

import cn.wise.sc.consume.business.entity.SysCoupon;
import cn.wise.sc.consume.business.entity.SysCouponDetail;
import cn.wise.sc.consume.business.entity.SysEnterprise;
import cn.wise.sc.consume.business.mapper.SysCouponDetailMapper;
import cn.wise.sc.consume.business.mapper.SysCouponMapper;
import cn.wise.sc.consume.business.model.CouponAppListVO;
import cn.wise.sc.consume.business.model.CouponDetailVO;
import cn.wise.sc.consume.business.model.CouponListVO;
import cn.wise.sc.consume.business.model.PageTableRequest;
import cn.wise.sc.consume.business.service.ISysCouponService;
import cn.wise.sc.consume.business.wrapper.page.Query;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.ibatis.annotations.Param;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author ztw
 * @since 2020-07-31
 */
@Service
public class SysCouponServiceImpl extends ServiceImpl<SysCouponMapper, SysCoupon> implements ISysCouponService {

	private static final Logger log = LoggerFactory.getLogger("SysCouponServiceImpl");

	@Autowired
	private SysCouponMapper couponMapper;

	@Resource
	private SysCouponDetailMapper sysCouponDetailMapper;

	@Resource
	private SysCouponMapper sysCouponMapper;

	@Override
	public IPage<CouponListVO> getPage(Page request, Map<String, Object> map) {
		IPage<CouponListVO> couponListVOS = couponMapper.getCouponPage(request,map);
		log.debug("优惠券列表{}");
		return couponListVOS;
	}

	@Override
	public CouponDetailVO getCouponDetail(Long id) {
		return couponMapper.getCouponDetail(id);
	}

	@Override
	public List<CouponAppListVO> getCouponAppList(String coridc, String usridc) {
		QueryWrapper<CouponAppListVO> qw=new QueryWrapper<>();
		qw.eq("status",1);
		qw.eq("isDelete",1);
		List<CouponAppListVO> list = couponMapper.getCouponAppList(coridc, usridc ,qw);
		List<CouponAppListVO> rts = new ArrayList<>(list.size());
		if (list!=null){
			for (CouponAppListVO couponAppListVO:list){
				Long coupId = couponAppListVO.getId();
				List<SysCoupon> byCouponId = sysCouponMapper.getById(coupId);

				for (SysCoupon sysCoupon:byCouponId){
					boolean equals = sysCoupon.getStatus() == 1;
					boolean equals1 = sysCoupon.getIsDelete() == 1;
					if ((equals && equals1)){
						rts.add(couponAppListVO);
					}
				}
			}
		}

		return rts;
	}

}
