package cn.wise.sc.consume.business.util;

import cn.hutool.json.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.github.qcloudsms.SmsSingleSender;
import com.github.qcloudsms.SmsSingleSenderResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.data.redis.core.StringRedisTemplate;
import javax.annotation.Resource;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;
import javax.xml.ws.http.HTTPException;
import java.io.*;
import java.security.Key;
import java.security.SecureRandom;
import java.util.Random;

/**
 * 短信服务类
 * 2020-02-10
 */
public class SMSUtil {

	private static final Logger log = LoggerFactory.getLogger("adminLogger");

	//短信平台参考短信平台接口文档
	private static final String MESSAGE = "6db696baa08d11ea9ec30050569875ce";
	private static final String PASSWORD = "123123123123123121";
	private static final String UAT = "https://publicnoteserver.bcs.cmbchina.com";
	private static final String URL = "/publicNoteServer/decrypt";

	//短信应用SDK AppID
	private static final int appid = 1400313569; //140开头
	//短信应用SDK AppKey
	private static final String appkey = "e3baf74f68aebb837fe9263a3cd4c821";
	//短信模板ID， 需要在短信应用中申请
	private static final int TTEMPLATEID = 532621;
	//签名
	private static final String SMSSING = "腾闻";




	 /**
      * 自定义短信内容发送
      * @param msg 短信内容
      * @param number 用户手机号
      * @return OK 成功  null 失败
      */
	 public static String sendMess(String msg , String number){
		try {
			SmsSingleSender ssender = new SmsSingleSender(appid, appkey);
			SmsSingleSenderResult result = ssender.send(0, "86", number,msg, "", "");
			System.out.print(result);
			return result.errMsg;
		} catch (HTTPException e) {
			// HTTP响应码错误
			e.printStackTrace();
		} catch (JSONException e) {
		    // json解析错误
		    e.printStackTrace();
		} catch (IOException e) {
			// 网络IO错误
			e.printStackTrace();
		} catch (com.github.qcloudsms.httpclient.HTTPException e) {
			e.printStackTrace();
		}
		return null;
    }

	@Resource
	private StringRedisTemplate stringRedisTemplate;

	/**
     * 指定模板ＩＤ发送短信
     * @param number 用户手机号
     * @return OK 成功  null 失败
     */
	public static String sendMesModel(String number){
		try {
			int yzm = random();
			String code = Integer.toString(yzm);
			String[] params = {code};;//{参数}
			SmsSingleSender ssender = new SmsSingleSender(appid, appkey);
			SmsSingleSenderResult result = ssender.sendWithParam("86", number,TTEMPLATEID, params, SMSSING, "", ""); // 签名参数未提供或者为空时，会使用默认签名发送短信
			if (result.result == 0) {
				//发送成功返回验证码
				return code;

			}
			System.out.print(result);

			return result.errMsg;//OK
		} catch (HTTPException e) {
			// HTTP响应码错误
			e.printStackTrace();
		} catch (JSONException e) {
			// json解析错误
			e.printStackTrace();
		} catch (IOException e) {
			// 网络IO错误
            e.printStackTrace();
		} catch (com.github.qcloudsms.httpclient.HTTPException e) {
			e.printStackTrace();
		}
        return null;
	}


	//自定义方式发送短信，（不用模板和签名）
	public static String send(String phoneNumbers) {
		int yzm = random();
		String num = Integer.toString(yzm);
		SmsSingleSenderResult result = null;
		try {
			String smsSign = "" + yzm + "为您的登录验证码，请于2分钟内填写。如非本人操作，请忽略本短信。"; // NOTE: 这里的签名"腾讯云"只是一个示例，真实的签名需要在短信控制台中申请，另外签名参数使用的是`签名内容`，而不是`签名ID
			SmsSingleSender ssender = new SmsSingleSender(appid, appkey);
			result = ssender.send(0, "86", phoneNumbers, smsSign, "", "");
			if (result.result == 0) {
				//发送成功返回验证码
				return num;
			}
		} catch (HTTPException e) {
			//System.out.println("HTTP响应码错误");
			return result.toString();
		} catch (JSONException e) {
			//System.out.println("json解析错误");
			return result.toString();
		} catch (IOException e) {
			//System.out.println(" 网络IO错误");
			return result.toString();
		} catch (com.github.qcloudsms.httpclient.HTTPException e) {
			e.printStackTrace();
		}
		return result.toString();
	}

	/*
		生成6位验证码
	 */
	private static int random() {
		Random r = new Random();
		StringBuffer sb = new StringBuffer();
		int[] c = new int[6];
		for (int i = 0; i < 6; i++) {
			c[i] = r.nextInt(9) + 1;
			sb.append(c[i]);
		}
		return Integer.parseInt(sb.toString());

	}


	public static void main(String[] args) {
//		String send = SMSUtil.send("15010051933");
//		String send2 = SMSUtil.sendMess("okokok", "15010051933");
		try {
			String message = "6db696baa08d11ea9ec30050569875ce";
			String password = "123123123123123121";
			String aaa = SMSUtil.enCode(message, password);
			JSONObject jsonObject = new JSONObject();
			jsonObject.put("enMsg",aaa);
			jsonObject.put("password", password);
			jsonObject.put("phoneReal", "15010051933");
			jsonObject.put("keyValue1", "1234");
			String jsonString = jsonObject.toJSONString();
			String url = "https://publicnoteserver.bcs.cmbchina.com/publicNoteServer/decrypt";
			String end = HttpClientUtil.doPostJson(url, jsonString);

			System.out.println(end);
		} catch (Exception e) {
			e.printStackTrace();
		}

	}




	public static Boolean sendCode(String phone,String code){
		try {
			String message = MESSAGE;
			String password = PASSWORD;
			String aaa = SMSUtil.enCode(message, password);
			JSONObject jsonObject = new JSONObject();
			jsonObject.put("enMsg",aaa);
			jsonObject.put("password", password);
			jsonObject.put("phoneReal", phone);
			jsonObject.put("keyValue1", code);
			String jsonString = jsonObject.toJSONString();
			String url = UAT+URL;
			String end = HttpClientUtil.doPostJson(url, jsonString);
			JSONObject jsonObject1 = JSONObject.parseObject(end);
			return jsonObject1.getBoolean("success");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;

	}

	/**
	 * 加密方式：AES加密
	 * @param message
	 * @param password
	 * @return
	 * @throws Exception
	 */
	private static String enCode(String message,String password) throws Exception {
		//加密
		KeyGenerator generator;
		generator = KeyGenerator.getInstance("AES");
		SecureRandom random = SecureRandom.getInstance("SHA1PRNG");
		random.setSeed(password.getBytes());
		generator.init(128,random);
		SecretKey secretKey = generator.generateKey();
		byte[] keyBytes = secretKey.getEncoded();
		Key key = new SecretKeySpec(keyBytes, "AES");
		Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
		cipher.init(Cipher.ENCRYPT_MODE, key);
		byte[] encodeResult = cipher.doFinal(message.getBytes());
//byte[]转化为16进制字符串
		StringBuffer sBuffer = new StringBuffer();
		for(int i=0;i< encodeResult.length;i++) {
			String hexString = Integer.toHexString(encodeResult [i] & 0xFF);
			if(hexString.length() ==1) {
				hexString = '0' + hexString;
			}
			sBuffer.append(hexString.toUpperCase());
		}
		String enMsg = sBuffer.toString();
		return enMsg;
	}




}
